=== debian/changelog ===
pmemkv (1.4-1) unstable; urgency=medium

  * Upload upstream release to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 15 Feb 2021 16:37:23 +0100

pmemkv (1.4~rc1-1) experimental; urgency=medium

  * New upstream RC.
  * Enable arm64 and ppc64el.
  * Bump build-depend versions.
  * Add gdb for tests.
  * Add new symbols.
  * dh 13.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 11 Feb 2021 00:00:06 +0100

pmemkv (1.3-1) unstable; urgency=medium

  * New upstream release.
  * Add symbols for 1.3.
  * Add libpmemobj-cpp-dev to Deps for -dev.
  * Update expected output of c++-ex autopkgtest.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 07 Dec 2020 20:26:39 +0100

pmemkv (1.2-2) unstable; urgency=medium

  * Add symbols that appeared in 1.2.
  * Paper over libunwind calling close(-1)/  Closes: #967091.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 31 Aug 2020 11:06:30 +0200
